<?php

// The URL to push the feed to.
define('PUSHTO', 'http://www.worldsiteindex.com/feeds/ping.php');

// The list of available tags
$tagList = array(
	'miscellaneous',
	'babies and children',
	'marketing',
	'real estate',
	'arts',
	'business',
	'travel and tourism',
	'sports',
	'life',
	'entertainment',
	'food',
	'music',
	'technology',
	'romance and relationships',
	'software',
	'movies',
	'culture',
	'internet',
	'family',
	'shopping',
	'fashion',
	'industrial'
);
asort($tagList);
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Push News</title>
<style type="text/css">
<!--
body {
	color: #000;
	font-family: trebuchet ms, verdana, arial, tahoma;
	font-size: 100.1%;
	background-color: #0A2B3F;
	text-align: center;
	margin: 0;
	padding: 20px 5%;
}

/* min width */
.width {
	min-width:770px;
}
* html .minwidth {
	border-left:770px solid #fff;
}
* html #pgframe {
	margin-left: -770px;
	position:relative;
}
/*\*/
* html .minwidth, * html #pgframe {
	height: 1px;
}
/**/
/* end min width */

/* Container for page */
#pgframe {
	text-align: left;
	font-size: 80%;
	color: #333;
	background-color: #fff;
	padding: 8px;
}

.clear { clear: both; overflow: hidden; height: 0; line-height: 0; }
img { border: none; padding: 0; margin: 0; display: block; }
.cent { text-align: center; }
label { display: block; }
h1 { font-size: 150%; margin: 10px 0; padding: 0 0 .25em 0; }
a { color: #447AAC; font-weight: bold; }
a:hover { color: #9C0204; text-decoration: none; }

#item { width: 35em; margin: 0 auto; }

.errorbox {
	background-color: #FFFF99;
	border: 1px solid;
	border-color: #c90000;
	padding: 4px 8px;
	margin: 0 15% 10px 15%;
	text-align: left;
}

-->
</style>
</head>
<?php
$tag = '0';
$key = $title = $url = $story = '';
$msg = array();
$step = 0;
if(isset($_POST['postItem']) || isset($_POST['postDelete'])) {

	$key = trim(gpcParam($_POST['key']));
	$tag = trim(gpcParam($_POST['tag']));
	$title = trim(gpcParam($_POST['title']));
	$url = trim(gpcParam($_POST['url']));
	$story = trim(gpcParam($_POST['story']));
	$domain = trim(gpcParam($_POST['domain']));

	// Quick check information
	if(!isset($tagList[$tag]))
		$msg[] = 'Please select a tag from the available list.';
	if(strlen($key) != 32)
		$msg[] = 'Key is incorrect.';
	if(!strlen($title))
		$msg[] = 'Title is required.';
	else if(strlen($title) > 64)
		$msg[] = 'Title must be less than 65 characters.';
	if(!strlen($url))
		$msg[] = 'URL is required.';
	else if(strlen($url) > 200)
		$msg[] = 'URL must be less than 200 characters.';
	if(!strlen($story))
		$msg[] = 'Story is required.';
	else if(strlen($story) > 400)
		$msg[] = 'Story must be less than 400 characters.';

	$u = parse_url($domain);
	if(!isset($u['scheme']) || !isset($u['host']))
		$msg[] = 'The domain name is malformed';
	else
		$domain = $u['scheme'] . '://' . $u['host'] . '/';

	if(!count($msg))
		$step = 1;
}
else
	$domain = 'http://' . $_SERVER['HTTP_HOST'] . '/';
?>
<body>
<div class="width"><div class="minwidth"><div id="pgframe">

	<div><a href="http://www.worldsiteindex.com/"><img src="logo.gif" width="346" height="92" alt="World Site Index Web Directory" /></a></div>

	<h1>Post News Item to World Site Index</h1>
	<?php
		if(count($msg)) {
			echo "<div class=\"errorbox\">\n";
			foreach($msg as $m)
				echo "<p>$m</p>\n";
			echo "</div>\n";
		}
	?>
	<?php
		if($step == 1) {
			echo "<div class=\"errorbox\">\n";

			$publish = '<' . '?xml version="1.0" encoding="iso-8859-1"?' . ">\n";
			$publish .= "<publish type=\"livenews\">\n";
			$publish .= '<tag>' . $tagList[$tag] . "</tag>\n";
			$publish .= '<title>' . htmlentities($title) . "</title>\n";
			$publish .= "<story><![CDATA[\n";
			$publish .= htmlentities($story) . "\n";
			$publish .= "]]></story>\n";
			$publish .= '<url>' . htmlentities($url) . "</url>\n";
			$publish .= "</publish>\n";
			$publish = 'publish=' . urlencode($publish);

			$reply = '';

			// Use curl if possible
			if(extension_loaded('curl')) {
				$c = curl_init(PUSHTO . '?url=' . urlencode($domain) . '&key=' . urlencode($key) . (isset($_POST['postDelete']) ? '&delete=1' : ''));
				curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($c, CURLOPT_TIMEOUT, 30);
				curl_setopt($c, CURLOPT_HEADER, 1);
				curl_setopt($c, CURLOPT_FOLLOWLOCATION, 0);
				curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
				curl_setopt($c, CURLOPT_POST, 1);
				curl_setopt($c, CURLOPT_POSTFIELDS, $publish);
				$reply = curl_exec($c);
				curl_close($c);
			}
			// Try using sockets
			else {
				$u = parse_url(PUSHTO);
				$errno = $errstr = '';
				$fp = fsockopen($u['host'], 80, $errno, $errstr, 30);
				if(!$fp) {
					echo "<p>Unable to write to remote directory.</p>";
				} else {
					fputs($fp, 'POST ' . $u['path'] . '?url=' . urlencode($domain) . '&key=' . urlencode($key) . (isset($_POST['postDelete']) ? '&delete=1' : '') . " HTTP/1.0\r\n");
					fputs($fp, 'Host: ' . $u['host'] . "\r\n");
					fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
					fputs($fp, "Content-length: " . strlen($publish) . "\r\n");
					fputs($fp, "Connection: close\r\n\r\n");
					fputs($fp, $publish . "\r\n\r\n");
					while (!feof($fp)) {
						$reply .= fgets($fp, 128);
					}
					fclose($fp);
				}
			}
			
			// Display results
			$r = array();
			if(preg_match('/<success>/', $reply)) {
				if(isset($_POST['postDelete'])) {
					echo "<p>News item has been deleted</p>\n";
					$step = 0;
				}
				else {
					echo "<p>News item has been sent and accepted.</p>\n";
					$step = 2;
				}
			}
			else if(preg_match('#<message>(.*)</message>#s', $reply, $r)) {
				echo "<p>Remote directory replied with error: " . $r[1] . "</p>\n";
				$step = 0;
			}
			else {
				echo "<p>Failed to send news item to remote directory.</p>\n";
				$step = 0;
			}
			echo "</div>\n";
		}
	?>
	<form action="pushlivenews.php" method="post" id="item">
		<p><label>Listed Domain:</label> <input name="domain" type="text" size="40" maxlength="200" <?php echo $step ? 'readonly="readonly"' : '';?> value="<?php echo htmlentities($domain); ?>" /></p>
		<p><label>Access Key:</label> <input name="key" type="text" size="40" maxlength="32" <?php echo $step ? 'readonly="readonly"' : '';?> value="<?php echo htmlentities($key); ?>" /></p>
		<p><label>Tag:</label>
		<?php
			if($step) {
				echo "<input name=\"tagtxt\" type=\"text\" size=\"64\" maxlength=\"64\" readonly=\"readonly\" value=\"" . $tagList[$tag] . "\" />\n";
				echo "<input name=\"tag\" type=\"hidden\" value=\"$tag\" />\n";
			}
			else {
				echo "<select name=\"tag\">\n";
				foreach($tagList as $v => $t)
					echo "<option value=\"$v\"" . ($v == $tag ? ' selected="selected"' : '') . ">$t</option>\n";
				echo "</select>\n";
			}
		?>
		</p>
		<p><label>Title:</label> <input name="title" type="text" size="64" maxlength="64" <?php echo $step ? 'readonly="readonly"' : '';?> value="<?php echo htmlentities($title); ?>" /></p>
		<p><label>URL:</label> <input name="url" type="text" size="64" maxlength="200" <?php echo $step ? 'readonly="readonly"' : '';?> value="<?php echo htmlentities($url); ?>" /></p>
		<p><label>Story:</label> <textarea name="story" cols="50" rows="20" <?php echo $step ? 'readonly="readonly"' : '';?>><?php echo htmlentities($story); ?></textarea></p>
		<p class="cent"><?php
			if($step)
				echo "<input name=\"postDelete\" type=\"submit\" value=\"Delete This News Item\" />\n";
			else
				echo "<input name=\"postItem\" type=\"submit\" value=\"Post News Item\" />\n";
		?></p>
		<?php
			if($step)
				echo "<p class=\"cent\"><a href=\"pushlivenews.php\">New item</a></p>\n";
		?>
	</form>
</div></div></div>

</body>
</html>
<?php

function gpcParam($p) {
	return(get_magic_quotes_gpc() ? stripslashes($p) : $p);
}

?>